%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   COmpute Derivative NEg Hessian Complete Likelihood Current Time
%       p(x_{t,k},y_t|x_{t,\k},x_{1:t-1},y_{1:t-1}
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



function [DerivativeNegHessian]=ComputationDerivativeNegHessian(Obs,MatrixTransformation,BlockSize,CondMean,InvCondCov,RearrangedCurrentState,ModelParam)

%%%%%%%%%
% Note to accelerate code owing to the specific properties of the
% independence of the observation (i.e. diagonal matrix)
% Otherwise DerivativeNegHessian of size (BlockSize,BlockSize,BlockSize)



CurrentState=RearrangedCurrentState(1:BlockSize,1);
RearrangedObs=MatrixTransformation*Obs;
RearrangedObs=RearrangedObs(1:BlockSize,1);

if strcmp(ModelParam.ModelObservation,'Poisson')
    

        DerivativeNegHessianLikelihood=zeros(BlockSize,1);
        DerivativeNegHessianLikelihood=ModelParam.MappingIntensityFunctionThirdDeriv(CurrentState(:),ModelParam.MappingIntensityCoeff,ModelParam.MappingIntensityScale);
        
         
   
elseif strcmp(ModelParam.ModelObservation,'Normal')

    
    DerivativeNegHessianLikelihood=zeros(BlockSize,1);%zeros(BlockSize,BlockSize,BlockSize);
    

end


% computation of the Hessian of the prior
if strcmp(ModelParam.ModelState,'Normal')
    
    DerivativeNegHessianPrior=zeros(BlockSize,1);
    

    
elseif strcmp(ModelParam.ModelState,'SkewedT')
    
    
    DerivativeNegHessianPrior=zeros(BlockSize,1);

end


DerivativeNegHessian=real(DerivativeNegHessianLikelihood+DerivativeNegHessianPrior);

