%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   Computation of the parameters of the conditional Normal Prior
%           Distribution
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function [CondMean,CondCov,RearrangedCurrentState]=ComputationParameterConditionalNormalPrior(MatrixTransformation,CurrentData,CurrentMean,CurrentCov,BlockSize)

RearrangedMean=MatrixTransformation*CurrentMean;
RearrangedCov=MatrixTransformation*CurrentCov*MatrixTransformation';

RearrangedCurrentState=MatrixTransformation*CurrentData(:,1);
InvCovStateMarginalized=inv(RearrangedCov(BlockSize+1:end,BlockSize+1:end));


% Computaiton of the conditional Moment
CondMean=RearrangedMean(1:BlockSize,1)...
        +RearrangedCov(1:BlockSize,BlockSize+1:end)*InvCovStateMarginalized*(RearrangedCurrentState(BlockSize+1:end,1)-RearrangedMean(BlockSize+1:end,1));
CondCov=RearrangedCov(1:BlockSize,1:BlockSize)-RearrangedCov(1:BlockSize,BlockSize+1:end)*InvCovStateMarginalized*RearrangedCov(BlockSize+1:end,1:BlockSize);
                        