function OutputSample=ConditionalRandomDrawFromSkewedT(CurrentState,BlockSize,MatrixTransformation,CurrentMean,ModelParam);


RearrangedMean=MatrixTransformation*CurrentMean;
RearrangedCov=MatrixTransformation*ModelParam.StateCovariance*MatrixTransformation';
RearrangedSkewness=MatrixTransformation*ModelParam.StateSkewness;
RearrangedCurrentState=MatrixTransformation*CurrentState;



DimensionToMarginalized=ModelParam.Dimension-BlockSize;

if DimensionToMarginalized>0 % In that case the conditional distrib is a GH distribution !

    InvCovStateMarginalized=inv(RearrangedCov(BlockSize+1:end,BlockSize+1:end));

    TermQ=(RearrangedCurrentState(BlockSize+1:end,1)-RearrangedMean(BlockSize+1:end,1))'...
        *InvCovStateMarginalized...
        *(RearrangedCurrentState(BlockSize+1:end,1)-RearrangedMean(BlockSize+1:end,1));


    Lambda=-0.5*ModelParam.StateDegreeFreedom-DimensionToMarginalized/2;
    Chi=TermQ+ModelParam.StateDegreeFreedom;
    Psi=RearrangedSkewness(BlockSize+1:end,1)'*InvCovStateMarginalized*RearrangedSkewness(BlockSize+1:end,1);

    CondMean=RearrangedMean(1:BlockSize,1)...
        +RearrangedCov(1:BlockSize,BlockSize+1:end)*InvCovStateMarginalized*(RearrangedCurrentState(BlockSize+1:end,1)-RearrangedMean(BlockSize+1:end,1));
    CondCov=RearrangedCov(1:BlockSize,1:BlockSize)-RearrangedCov(1:BlockSize,BlockSize+1:end)*InvCovStateMarginalized*RearrangedCov(BlockSize+1:end,1:BlockSize);
    CondSkewness=RearrangedSkewness(1:BlockSize,1)...
        -RearrangedCov(1:BlockSize,BlockSize+1:end)*InvCovStateMarginalized*RearrangedSkewness(BlockSize+1:end,1);



    W=gigrnd(Lambda,Psi,Chi);
    OutputSample=CondMean+W*CondSkewness+sqrt(W)*real(sqrtm(CondCov))*randn(BlockSize,1);
    
else
    
    
    W=1./gamrnd(ModelParam.StateDegreeFreedom/2,1/(ModelParam.StateDegreeFreedom/2));
    OutputSample=RearrangedMean+W*ModelParam.StateSkewness+sqrt(W)*ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);
    
end
    