function [ProposalMean,ProposalCov,ProposalCovSR,LogMarginalLikelihood]=OptimalSamplingNormal(Particles,NoParticles,Observation,ModelParam,t)
ObservationCovariance=ModelParam.VarNoise*eye(size(Observation,1));

if t==1
    PredictMean=ModelParam.InitialMean;
    PredictCov=ModelParam.StateCovariance;
    
    
    
    % --- UPDATE ----
    Innov=Observation(:,t)-ModelParam.ObservationTransition*PredictMean;
    InnovCov=ModelParam.ObservationTransition*PredictCov*ModelParam.ObservationTransition'+ObservationCovariance;
    Gain=PredictCov*ModelParam.ObservationTransition'*inv(InnovCov);
    
    ProposalMean=PredictMean+Gain*Innov;
    ProposalCov=PredictCov-Gain*ModelParam.ObservationTransition*PredictCov;
    LogMarginalLikelihood=0;
    ProposalCovSR=sqrtm(ProposalCov);
else
    % Do it once for all particles
    ProposalCov=zeros(ModelParam.Dimension,ModelParam.Dimension,1);
    ProposalMean=zeros(ModelParam.Dimension,NoParticles);
    
    % Covariance does not depend on the particles !
    PredictCov=ModelParam.StateCovariance;  
    InnovCov=ModelParam.ObservationTransition*PredictCov*ModelParam.ObservationTransition'+ObservationCovariance;
    InvInnovCov=inv(InnovCov);
    Gain=PredictCov*ModelParam.ObservationTransition'*InvInnovCov;
    ProposalCov=PredictCov-Gain*ModelParam.ObservationTransition*PredictCov;  
    % To ensure real symmetric matrix
    ProposalCov=triu(ProposalCov,1)+triu(ProposalCov,1)'+diag(diag(ProposalCov));
    ProposalCovSR=sqrtm(ProposalCov);    
    
    for j=1:NoParticles
        

        PredictMean=ModelParam.TransitionMatrix*Particles(:,j);
        

        % --- UPDATE ----
        Innov=Observation(:,t)-ModelParam.ObservationTransition*PredictMean;
        ProposalMean(:,j)=PredictMean+Gain*Innov;
        
        LogMarginalLikelihood(j)=ComputationLogNormal(Innov,zeros(ModelParam.Dimension,1),InvInnovCov,InnovCov);       
        


        
    end
    LogMarginalLikelihood=LogMarginalLikelihood-max(LogMarginalLikelihood);
end
    
    