function [Particles]=SequentialMCMC_ABC_JointPosteriorv1(ModelParam,Observation,Algo,State)

Particles.Analysis.NoRefinement=0;
Particles.Analysis.AcceptationRefinement=0;
Particles.Analysis.NoJointDraw=0;
Particles.Analysis.AcceptationJointDraw=0;
Particles.Analysis.AcceptationPreviousTerm=0;
Particles.Analysis.NoPreviousTerm=0;
NoMCMCIterations=Algo.NoBurnIn+Algo.Thining*Algo.NoParticles;
NoRefiningSteps=ModelParam.Dimension/Algo.BlockSize;

Particles.Data=zeros(ModelParam.Dimension,Algo.NoParticles,ModelParam.NoTimeSteps);
Particles.AuxVarHMC=zeros(ModelParam.Dimension,Algo.NoParticles,ModelParam.NoTimeSteps);
Particles.Mean=zeros(ModelParam.Dimension,ModelParam.NoTimeSteps);


Candidate.Data=zeros(ModelParam.Dimension,1);
Candidate.LogLikelihood=0;

Chosen.Data=zeros(ModelParam.Dimension,1);
Chosen.LogLikelihood=0;




for t=1:ModelParam.NoTimeSteps % Iteration over time samples
    
    if strcmp(Algo.SamplingTechnique,'Optimal') && strcmp(ModelParam.ModelState,'Normal') && strcmp(ModelParam.ModelObservation,'Normal')
       % Compute the different required quantities - Innovation + OptimalProposal
       if t==1
           InputParticles=[];
       else
           InputParticles=Particles.Data(:,:,t-1);
           
       end
       [ProposalMean,ProposalCov,ProposalCovSR,LogMarginalLikelihoodOptimal]=OptimalSamplingNormal(InputParticles,Algo.NoParticles,Observation,ModelParam,t);
    
    end
    
  
    
    NumParticles=1;
    for j=1:NoMCMCIterations % MCMC iteraion for one time sample
        
        
        
        
        if j==1 && t==1
            
            Chosen.Data(:,2)=zeros(ModelParam.Dimension,1);
            
            if strcmp(ModelParam.ModelState,'SkewedT')
                W=1./gamrnd(ModelParam.StateDegreeFreedom/2,1/(ModelParam.StateDegreeFreedom/2));
                Chosen.Data(:,1)=ModelParam.InitialMean+W*ModelParam.StateSkewness+sqrt(W)*ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);
            elseif strcmp(ModelParam.ModelState,'Normal') 
                
                if strcmp(Algo.SamplingTechnique,'Optimal') && strcmp(ModelParam.ModelObservation,'Normal')
                    Chosen.Data(:,1)=ProposalMean+ProposalCovSR*randn(ModelParam.Dimension,1);
                    
                else
                    Chosen.Data(:,1)=ModelParam.InitialMean+ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);
                end
                
            end
            

            Chosen.LogLikelihood=ComputationLogLikelihoodv1(Observation(:,t),ModelParam.ObservationTransition*Chosen.Data(:,1),ModelParam);
            

            
        elseif j==1 && t~=1
            
            if strcmp(Algo.SamplingTechnique,'Optimal') && strcmp(ModelParam.ModelState,'Normal') && strcmp(ModelParam.ModelObservation,'Normal')
                UniformPick=randsample(1:Algo.NoParticles,1,true,exp(LogMarginalLikelihoodOptimal));
                Chosen.Data(:,2)=Particles.Data(:,UniformPick,t-1);
                
                Chosen.Data(:,1)=ProposalMean(:,UniformPick)+(ProposalCovSR)*randn(ModelParam.Dimension,1);    
                
            else
                UniformPick=ceil(Algo.NoParticles*rand);

                Chosen.Data(:,2)=Particles.Data(:,UniformPick,t-1);

                if strcmp(ModelParam.ModelState,'SkewedT')
                    W=1./gamrnd(ModelParam.StateDegreeFreedom/2,1/(ModelParam.StateDegreeFreedom/2));
                    Chosen.Data(:,1)=ModelParam.TransitionMatrix*Chosen.Data(:,2)+W*ModelParam.StateSkewness+sqrt(W)*ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);
                elseif  strcmp(ModelParam.ModelState,'Normal')
                    Chosen.Data(:,1)=ModelParam.TransitionMatrix*Chosen.Data(:,2)+ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);    
                end


                Chosen.LogLikelihood=ComputationLogLikelihoodv1(Observation(:,t),ModelParam.ObservationTransition*Chosen.Data(:,1),ModelParam);
            end
        
            
        else % if t~=1 and j~=1
            
            
            RandomVariableWhatStepToDo=rand;
            if Algo.BothJointDraw_RefinementAtEachIteration==1 || RandomVariableWhatStepToDo<Algo.ProbaJointDraw % JOINT DRAW
                Particles.Analysis.NoJointDraw=Particles.Analysis.NoJointDraw+1;
                
                
                if strcmp(Algo.SamplingTechnique,'Optimal') && strcmp(ModelParam.ModelState,'Normal') && strcmp(ModelParam.ModelObservation,'Normal')
                    if t==1
                        Candidate.Data(:,2)=zeros(ModelParam.Dimension,1);
                        Candidate.Data(:,1)=ProposalMean+(ProposalCovSR)*randn(ModelParam.Dimension,1);
                    else
                        
                        
                        UniformPick=randsample(1:Algo.NoParticles,1,true,exp(LogMarginalLikelihoodOptimal));
                        
                        Candidate.Data(:,2)=Particles.Data(:,UniformPick,t-1);

                        Candidate.Data(:,1)=ProposalMean(:,UniformPick)+(ProposalCovSR)*randn(ModelParam.Dimension,1);                        
                    end
                    
                    AcceptanceRatio=1;
                else
                
                    if t==1

                        Candidate.Data(:,2)=zeros(ModelParam.Dimension,1);                    

                        if strcmp(ModelParam.ModelState,'SkewedT')
                            W=1./gamrnd(ModelParam.StateDegreeFreedom/2,1/(ModelParam.StateDegreeFreedom/2));
                            Candidate.Data(:,1)=ModelParam.InitialMean+W*ModelParam.StateSkewness+sqrt(W)*ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);
                        elseif strcmp(ModelParam.ModelState,'Normal')
                            Candidate.Data(:,1)=ModelParam.InitialMean+ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);
                        end
                    else

                        UniformPick=ceil(Algo.NoParticles*rand);
                        Candidate.Data(:,2)=Particles.Data(:,UniformPick,t-1);

                        if strcmp(ModelParam.ModelState,'SkewedT')
                            W=1./gamrnd(ModelParam.StateDegreeFreedom/2,1/(ModelParam.StateDegreeFreedom/2));
                            Candidate.Data(:,1)=ModelParam.TransitionMatrix*Candidate.Data(:,2)+W*ModelParam.StateSkewness+sqrt(W)*ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);
                        elseif strcmp(ModelParam.ModelState,'Normal')
                            Candidate.Data(:,1)=ModelParam.TransitionMatrix*Candidate.Data(:,2)+ModelParam.StateCovarianceSR*randn(ModelParam.Dimension,1);
                        end


                    end


                    Candidate.LogLikelihood=ComputationLogLikelihoodv1(Observation(:,t),ModelParam.ObservationTransition*Candidate.Data(:,1),ModelParam);

                    AcceptanceRatio=min([exp(Candidate.LogLikelihood-Chosen.LogLikelihood) 1]);
                end
                
                if rand<AcceptanceRatio
                    
                    Chosen=Candidate;
                    Particles.Analysis.AcceptationJointDraw=Particles.Analysis.AcceptationJointDraw+1;
                    
                end
                
                
                
            %else % REFINEMENT STEP PERFORMED WITH PROBA 1-Algo.ProbaJointDraw
            end
            if (Algo.BothJointDraw_RefinementAtEachIteration==1 || RandomVariableWhatStepToDo>=Algo.ProbaJointDraw) && strcmp(Algo.SamplingTechnique,'Optimal')==0
                
                if t>1 % Selection of Previous Term t-1 given t
                    Particles.Analysis.NoPreviousTerm=Particles.Analysis.NoPreviousTerm+1;
                    
                    CurrentMean=ModelParam.TransitionMatrix*Chosen.Data(:,2);
                    UniformPick=ceil(Algo.NoParticles*rand);
                    Candidate.Data(:,2)=Particles.Data(:,UniformPick,t-1);
                    CandidateMean=ModelParam.TransitionMatrix*Candidate.Data(:,2);%,ModelParam);
                
                    CandidateLogPrior=ComputationLogPrior(Chosen.Data(:,1),CandidateMean,ModelParam);
                    CurrentLogPrior=ComputationLogPrior(Chosen.Data(:,1),CurrentMean,ModelParam);
                    

                
                    AcceptanceRatio=min([1 exp(CandidateLogPrior-CurrentLogPrior)]);
                    if rand<AcceptanceRatio
                        Chosen.Data(:,2)=Candidate.Data(:,2);
                        Particles.Analysis.AcceptationPreviousTerm=Particles.Analysis.AcceptationPreviousTerm+1;
                        
                    end
                    
                end                
                
                if Algo.BlockSize==ModelParam.Dimension;%No need to do random permutation
                    randpermStateDimension=1:ModelParam.Dimension;%randperm(ModelParam.Dimension);%1:ModelParam.Dimension;%randperm(ModelParam.Dimension);
                else
                    randpermStateDimension=randperm(ModelParam.Dimension);
                end
                 

                for iii=1:NoRefiningSteps
                    Particles.Analysis.NoRefinement=Particles.Analysis.NoRefinement+1;
                    
                    Candidate=Chosen;
                    
                    
                    CurrentCov=ModelParam.StateCovariance;
                    CurrentSkewness=ModelParam.StateSkewness;
                    
                    IndexRefining=randpermStateDimension((1:Algo.BlockSize)+(iii-1)*Algo.BlockSize);
                    
                    if t==1
                        

                        
                        CurrentMean=ModelParam.InitialMean;
                        [MatrixTransformation]=TransformationParametersBlockSampling(ModelParam.Dimension,iii,randpermStateDimension,Algo.BlockSize);%CurrentMean,ModelParam.StateCovariance,ModelParam.StateSkewness);

                        
                    else
                        CurrentMean=ModelParam.TransitionMatrix*Candidate.Data(:,2);
                        [MatrixTransformation]=TransformationParametersBlockSampling(ModelParam.Dimension,iii,randpermStateDimension,Algo.BlockSize);%CurrentMean,ModelParam.StateCovariance,ModelParam.StateSkewness);
                        
                        
                    end
                    
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    % CHOICE OF THE DIFFERENT MCMC KERNEL
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    
                    if  strcmp(Algo.SamplingTechnique,'PRIOR')
                        

                        %Sampling
                        if strcmp(ModelParam.ModelState,'Normal')
                            
                            % Compute the Parameters of the conditional Prior
                            if Algo.BlockSize==ModelParam.Dimension
                                
                                CondMean=CurrentMean;
                                CondCov=ModelParam.StateCovariance;
                                RearrangedCurrentState=Chosen.Data(:,1);
                                InvCondCov=ModelParam.StateCovarianceInv;
                                CondCovSR=ModelParam.StateCovarianceSR;
                                
                            else         
                                
                                [CondMean,CondCov,RearrangedCurrentState]=ComputationParameterConditionalNormalPrior(MatrixTransformation,Chosen.Data(:,1),CurrentMean,ModelParam.StateCovariance,Algo.BlockSize);
                                CondCov=triu(CondCov,1)+triu(CondCov,1)'+diag(diag(CondCov));
                                CondCovSR=sqrtm(CondCov);
                                
                            end
                            
                            ConditionalSample=CondMean+real(CondCovSR)*randn(Algo.BlockSize,1);
                            
                        elseif strcmp(ModelParam.ModelState,'SkewedT')
                            
                            ConditionalSample=ConditionalRandomDrawFromSkewedT(Chosen.Data(:,1),Algo.BlockSize,MatrixTransformation,CurrentMean,ModelParam);
                            
                        end
                        
                        Candidate.Data(IndexRefining,1)=ConditionalSample;
                        
                        
                        
                        ChosenLogPrior=0;
                        CandidateLogPrior=0;
                        ChosenLogProposal=0;
                        CandidateLogProposal=0;
                        
                    elseif strcmp(Algo.SamplingTechnique,'SMALA') % Preconditionned MALA - Indentity Matrix
                        
                        
                        
                        
                        %%%%%%%%%%%%%%%%%%
                        % computation of the parameters of the conditional  prior
                        if Algo.BlockSize==ModelParam.Dimension
                            CondMean=CurrentMean;
                            CondCov=ModelParam.StateCovariance;
                            RearrangedCurrentState=Chosen.Data(:,1);
                            InvCondCov=ModelParam.StateCovarianceInv;
                        else                        
                            [CondMean,CondCov,RearrangedCurrentState]=ComputationParameterConditionalNormalPrior(MatrixTransformation,Chosen.Data(:,1),CurrentMean,ModelParam.StateCovariance,Algo.BlockSize);
                        
                            InvCondCov=inv(CondCov);
                        end
                        
                        %%%%%%%%%%%%%%%%%%
                        % Computation of the gradient
                        [Gradient]=ComputationGradient(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,RearrangedCurrentState,ModelParam);
                        
                        %%%%%%%%%%%%%%%%%%
                        % Sampling from the MALA preconditionned with unitary identity matrix
                        ConditionalSample=RearrangedCurrentState(1:Algo.BlockSize,1)+(Algo.StepSize^2/2)*Gradient+Algo.StepSize*randn(Algo.BlockSize,1);
                        
                        
                        Candidate.Data(IndexRefining,1)=ConditionalSample;
                        
                        %%%%%%%%%%%%%%%%%%
                        % Computation of the Prior And Proposal 
                        CandidateLogProposal=ComputationLogNormal(ConditionalSample,RearrangedCurrentState(1:Algo.BlockSize,1)+(Algo.StepSize^2/2)*Gradient,eye(Algo.BlockSize)/(Algo.StepSize^2),(Algo.StepSize^2)*eye(Algo.BlockSize));
                        CandidateLogPrior=ComputationLogPrior(Candidate.Data(:,1),CurrentMean,ModelParam);
                        
                        %%%%%%%%%%%%%%%%%%
                        % Computation of the Gradient with Candidate Point
                        PointForGradient=[ConditionalSample;RearrangedCurrentState(Algo.BlockSize+1:end,1)];
                        [GradientForCurrent]=ComputationGradient(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,PointForGradient,ModelParam);
                        
                        %%%%%%%%%%%%%%%%%%
                        % Computation of Prior and Proposal For Current
                        ChosenLogProposal=ComputationLogNormal(Chosen.Data(IndexRefining,1),Candidate.Data(IndexRefining,1)+(Algo.StepSize^2/2)*GradientForCurrent,eye(Algo.BlockSize)/(Algo.StepSize^2),(Algo.StepSize^2)*eye(Algo.BlockSize));
                        ChosenLogPrior=ComputationLogPrior(Chosen.Data(:,1),CurrentMean,ModelParam);

                        
                    elseif strcmp(Algo.SamplingTechnique,'SimplSmMALA') || strcmp(Algo.SamplingTechnique,'SmMALA')
                        % Simplified SmMALA or SmMALA - the only diff will
                        % be the drift term

                        

                        
                        %%%%%%%%%%%%%%%%%%
                        % computation of the parameters of the conditional  prior
                        if Algo.BlockSize==ModelParam.Dimension
                            CondMean=CurrentMean;
                            CondCov=ModelParam.StateCovariance;
                            RearrangedCurrentState=Chosen.Data(:,1);
                            InvCondCov=ModelParam.StateCovarianceInv;
                        else                        
                            [CondMean,CondCov,RearrangedCurrentState]=ComputationParameterConditionalNormalPrior(MatrixTransformation,Chosen.Data(:,1),CurrentMean,ModelParam.StateCovariance,Algo.BlockSize);
                        
                            InvCondCov=inv(CondCov);
                        end
                        
                        %%%%%%%%%%%%%%%%%%
                        % Computation of the gradient
                        [Gradient]=ComputationGradient(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,RearrangedCurrentState,ModelParam);

                        %%%%%%%%%%%%%%%%%%
                        % Computation of the Negative Hessian
                        
                        [NegHessian,Veig,Deig,DeigTrans]=ComputationNegHessian(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,RearrangedCurrentState,ModelParam);
                        InvNegHessian=inv(NegHessian);
                        SRInvNegHessian=real(sqrtm(InvNegHessian));
                        

                        if strcmp(Algo.SamplingTechnique,'SmMALA')
                            % Computation of the Third Derivative for the
                            % drift term
                            [DerivativeNegHessian]=ComputationDerivativeNegHessian(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,RearrangedCurrentState,ModelParam);
                            
                            [Drift]=ComputationDrifPosDepMALA(InvNegHessian,DerivativeNegHessian,Veig,Deig,DeigTrans,ModelParam.AlphaPosDefMatrix,Algo.BlockSize,ModelParam.ModelObservation);

                        else
                            
                            Drift=zeros(Algo.BlockSize,1);
                            
                        end

                        %%%%%%%%%%%%%%%%%%
                        % Sampling the Candidate
                        ConditionalSample=Chosen.Data(IndexRefining,1)+(Algo.StepSize^2/2)*InvNegHessian*Gradient+(Algo.StepSize^2)*Drift+Algo.StepSize*SRInvNegHessian*randn(Algo.BlockSize,1);

                        Candidate.Data(IndexRefining,1)=(ConditionalSample);
                        
                        %%%%%%%%%%%%%%%%%%
                        % Computation of the Prior And Proposal - Warning input Parameter is Inv Cov matrix
                        CandidateLogProposal=ComputationLogNormal(Candidate.Data(IndexRefining,1),Chosen.Data(IndexRefining,1)+(Algo.StepSize^2/2)*InvNegHessian*Gradient+(Algo.StepSize^2)*Drift,NegHessian/(Algo.StepSize^2),(Algo.StepSize^2)*InvNegHessian);
                        CandidateLogPrior=ComputationLogPrior(Candidate.Data(:,1),CurrentMean,ModelParam);
                        
                        
                        %%%%%%%%%%%%%%%%%%
                        % Computation of the Gradient with Candidate Point
                        PointForGradient=[ConditionalSample;RearrangedCurrentState(Algo.BlockSize+1:end,1)];
                        [GradientForCurrent]=ComputationGradient(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,PointForGradient,ModelParam);
                        [NegHessianForCurrent,VeigCurrent,DeigCurrent,DeigTransCurrent]=ComputationNegHessian(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,PointForGradient,ModelParam);
                        InvNegHessianForCurrent=inv(NegHessianForCurrent);
                        
                        
                        if strcmp(Algo.SamplingTechnique,'SmMALA')
                            % Computation of the Third Derivative
                            [DerivativeNegHessianForCurrent]=ComputationDerivativeNegHessian(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,PointForGradient,ModelParam);
                            
                            % Computation of the drift Term
                            
                            [DriftForCurrent]=ComputationDrifPosDepMALA(InvNegHessianForCurrent,DerivativeNegHessianForCurrent,VeigCurrent,DeigCurrent,DeigTransCurrent,ModelParam.AlphaPosDefMatrix,Algo.BlockSize,ModelParam.ModelObservation);

                            
                            
                        else
                            
                            DriftForCurrent=zeros(Algo.BlockSize,1);
                            
                        end                        
                        
                        
                        %%%%%%%%%%%%%%%%%%
                        % Computation of Prior and Proposal For Current
                        ChosenLogProposal=ComputationLogNormal(Chosen.Data(IndexRefining,1),Candidate.Data(IndexRefining,1)+(Algo.StepSize^2/2)*InvNegHessianForCurrent*GradientForCurrent+(Algo.StepSize^2)*DriftForCurrent,NegHessianForCurrent/(Algo.StepSize^2),(Algo.StepSize^2)*InvNegHessianForCurrent);
                        ChosenLogPrior=ComputationLogPrior(Chosen.Data(:,1),CurrentMean,ModelParam);
                        
                    elseif strcmp(Algo.SamplingTechnique,'SHMC')%Algo.SamplingTechnique=='HMC '

                        %%%%%%%%%%%%%%%%%%%%%%%%%%
                        % Draw auxiliary variable
                        % Assume IndependepentMatrix
                        Candidate.AuxVarHMC(IndexRefining,1)=Algo.SRInvCovAuxVarHMC(IndexRefining,IndexRefining)*randn(Algo.BlockSize,1);
                        Chosen.AuxVarHMC(IndexRefining,1)=Candidate.AuxVarHMC(IndexRefining,1); % Accept this move - its a Gibbs move !! 

                        %%%%%%%%%%%%%%%%%%
                        % computation of the parameters of the conditional  prior
                        if Algo.BlockSize==ModelParam.Dimension
                            CondMean=CurrentMean;
                            CondCov=ModelParam.StateCovariance;
                            RearrangedCurrentState=Chosen.Data(:,1);
                            InvCondCov=ModelParam.StateCovarianceInv;
                        else                        
                            [CondMean,CondCov,RearrangedCurrentState]=ComputationParameterConditionalNormalPrior(MatrixTransformation,Chosen.Data(:,1),CurrentMean,ModelParam.StateCovariance,Algo.BlockSize);
                        
                            InvCondCov=inv(CondCov);
                        end
                        

                        %%%%%%%%%%%%%%%%%%
                        % Perform the Leapfrog
                        [ConditionalSample,CondAuxVarHMC]=LeapfrogForHMC(Candidate.AuxVarHMC(IndexRefining,1),Chosen.Data(IndexRefining,1),Observation(:,t),MatrixTransformation,CurrentMean,ModelParam,Algo,IndexRefining,CondMean,InvCondCov,Algo.InvCovAuxVarHMC);

                        


                        Candidate.Data(IndexRefining,1)=ConditionalSample;
                        Candidate.AuxVarHMC(IndexRefining,1)=CondAuxVarHMC;



                        %%%%%%%%%%%%%%%%%%
                        % Computation of the prior

                        CandidateLogPrior=ComputationLogPrior(Candidate.Data(:,1),CurrentMean,ModelParam);
                        ChosenLogPrior=ComputationLogPrior(Chosen.Data(:,1),CurrentMean,ModelParam);
                        

                        %%%%%%%%%%%%%%%%%%
                        % Computaiton of the prior
                        % Compute the target of momentum variables !
                        % It's not a proposal so the negative sign !!
                        CandidateLogProposal=-ComputationLogNormal(Candidate.AuxVarHMC(IndexRefining,1),zeros(Algo.BlockSize,1),Algo.InvCovAuxVarHMC(IndexRefining,IndexRefining),Algo.CovAuxVarHMC);
                        ChosenLogProposal=-ComputationLogNormal(Chosen.AuxVarHMC(IndexRefining,1),zeros(Algo.BlockSize,1),Algo.InvCovAuxVarHMC(IndexRefining,IndexRefining),Algo.CovAuxVarHMC);


                       
                    elseif strcmp(Algo.SamplingTechnique,'SmHMC')%Algo.SamplingTechnique=='HMC '

                        %%%%%%%%%%%%%%%%%%
                        % computation of the parameters of the conditional  prior
                        if Algo.BlockSize==ModelParam.Dimension
                            CondMean=CurrentMean;
                            CondCov=ModelParam.StateCovariance;
                            RearrangedCurrentState=Chosen.Data(:,1);
                            InvCondCov=ModelParam.StateCovarianceInv;
                        else
                            [CondMean,CondCov,RearrangedCurrentState]=ComputationParameterConditionalNormalPrior(MatrixTransformation,Chosen.Data(:,1),CurrentMean,ModelParam.StateCovariance,Algo.BlockSize);
                        
                            InvCondCov=inv(CondCov);
                        end
                        
                        %%%%%%%%%%%%%%%%%%%%%%%%%%
                        % Compute Hessian to draw Momentum variables

                        [NegHessian]=ComputationNegHessian(Observation(:,t),MatrixTransformation,Algo.BlockSize,CondMean,InvCondCov,RearrangedCurrentState,ModelParam);
                        InvNegHessian=inv(NegHessian);
                        SRNegHessian=real(sqrtm(NegHessian));
                        
                        %%%%%%%%%%%%%%%%%%%%%%%%%%
                        % Draw auxiliary variable

                        Candidate.AuxVarHMC(IndexRefining,1)=SRNegHessian(1:Algo.BlockSize,1:Algo.BlockSize)*randn(Algo.BlockSize,1);
                        Chosen.AuxVarHMC(IndexRefining,1)=Candidate.AuxVarHMC(IndexRefining,1); % Accept this move - its a Gibbs move !! 

                        %%%%%%%%%%%%%%%%%%%%%%%%%%
                        % Perform either a Leapfrog or Generalized Leapfrog
                        % Depending on the model
                        if Algo.GeneralizedLeapfrogRequired==0

                            %%%%%%%%%%%%%%%%%%
                            % Perform the Leapfrog
                            [ConditionalSample,CondAuxVarHMC]=LeapfrogForHMC(Candidate.AuxVarHMC(IndexRefining,1),Chosen.Data(IndexRefining,1),Observation(:,t),MatrixTransformation,CurrentMean,ModelParam,Algo,IndexRefining,CondMean,InvCondCov,InvNegHessian);

                            
                            InvNegHessianCandidate=InvNegHessian;
                            NegHessianCandidate=NegHessian;
                        else
                            
                            %%%%%%%%%%%%%%%%%%
                            % Perform the Generalized Leapfrog
                            [ConditionalSample,CondAuxVarHMC,InvNegHessianCandidate,NegHessianCandidate]=GeneralizedLeapfrogFormHMC(Candidate.AuxVarHMC(IndexRefining,1),Chosen.Data(IndexRefining,1),Observation(:,t),MatrixTransformation,CurrentMean,ModelParam,Algo,IndexRefining,CondMean,InvCondCov);
                            
                            
                        end


                        Candidate.Data(IndexRefining,1)=ConditionalSample;
                        Candidate.AuxVarHMC(IndexRefining,1)=CondAuxVarHMC;

                        %%%%%%%%%%%%%%%%%%
                        % Computaiton of the prior

                        CandidateLogPrior=ComputationLogPrior(Candidate.Data(:,1),CurrentMean,ModelParam);
                        ChosenLogPrior=ComputationLogPrior(Chosen.Data(:,1),CurrentMean,ModelParam);
                        
                       %%%%%%%%%%%%%%%%%%
                        % Computaiton of the target of the momentum
                        % variables to be included in the acceptance ratio
                        % It's not a proposal so the negative sign !!
                        CandidateLogProposal=-ComputationLogNormal(Candidate.AuxVarHMC(IndexRefining,1),zeros(Algo.BlockSize,1),InvNegHessianCandidate,NegHessianCandidate);
                        ChosenLogProposal=-ComputationLogNormal(Chosen.AuxVarHMC(IndexRefining,1),zeros(Algo.BlockSize,1),InvNegHessian,NegHessian);


                


                    end                    

                    
                    if Algo.DisplayProposalCandidate
                        %%%%%%%%%%%%%%%%%%
                        % Display Proposal and Current Value MC

                        figure(99);clf;plot(Chosen.Data(:,1));hold on;plot(Candidate.Data(:,1),'g');hold on;plot(State(:,t),'r')
                        hold on;plot(Observation(:,t),'k')
                        axis([1 ModelParam.Dimension 0 max(State(:,t))+1])
                        drawnow;
                    end

                    

                    %%%%%%%%%%%%%%%%%%
                    % Computation of the Likelihood for the Proposed value
                    Candidate.LogLikelihood=ComputationLogLikelihoodv1(Observation(:,t),ModelParam.ObservationTransition*Candidate.Data(:,1),ModelParam);
                    
                    
                    %%%%%%%%%%%%%%%%%%
                    % Computation Acceptance Ratio
                    AcceptanceRatio=min([exp(Candidate.LogLikelihood+CandidateLogPrior-CandidateLogProposal+ChosenLogProposal-Chosen.LogLikelihood-ChosenLogPrior) 1]);
                    
                    
                    

                    if sum(isnan(Candidate.Data(:,1)))>0
                        AcceptanceRatio=0;
                    end
                    
                    

                
                    if rand<AcceptanceRatio
                    
                        Chosen=Candidate;
                        Particles.Analysis.AcceptationRefinement=Particles.Analysis.AcceptationRefinement+1;
                        
                    
                    end                    
                    

                                    
                        
                end  
                        
         
                
                
            end
            
        end
            
        %%%%%%%%%%%%%%%%%%
        % Saved As Particles for next iteration after BurnIn
        %
        if j>Algo.NoBurnIn && mod(j-Algo.NoBurnIn,Algo.Thining)==0
            

            Particles.Data(:,NumParticles,t)=Chosen.Data(:,1);
            NumParticles=NumParticles+1;
            
        end            
                
         
        
    end
   
     % Computation of the posterior mean
    Particles.Mean(:,t)=mean(Particles.Data(:,:,t),2);
                
    % Computation of the Covariance    
    Particles.Cov(:,:,t)=zeros(ModelParam.Dimension);
    for iCov=1:Algo.NoParticles
        Particles.Cov(:,:,t)=Particles.Cov(:,:,t)+(1/Algo.NoParticles)*(Particles.Data(:,iCov,t)-Particles.Mean(:,t))*(Particles.Data(:,iCov,t)-Particles.Mean(:,t))';
    end
           
                
                
end   
